VERSION 5.00
Begin VB.Form frmBinTree 
   Caption         =   "BinaryTree"
   ClientHeight    =   5355
   ClientLeft      =   2445
   ClientTop       =   1335
   ClientWidth     =   8475
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5355
   ScaleWidth      =   8475
   Begin VB.TextBox txtDTheta 
      Height          =   285
      Left            =   1200
      TabIndex        =   1
      Text            =   "36"
      Top             =   480
      Width           =   615
   End
   Begin VB.TextBox txtLengthScale 
      Height          =   285
      Left            =   1200
      TabIndex        =   0
      Text            =   ".75"
      Top             =   120
      Width           =   615
   End
   Begin VB.TextBox txtDepth 
      Height          =   285
      Left            =   1200
      MaxLength       =   2
      TabIndex        =   2
      Text            =   "5"
      Top             =   1080
      Width           =   615
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   600
      TabIndex        =   3
      Top             =   1560
      Width           =   615
   End
   Begin VB.PictureBox picCanvas 
      AutoRedraw      =   -1  'True
      Height          =   3855
      Left            =   1920
      ScaleHeight     =   253
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   325
      TabIndex        =   4
      Top             =   0
      Width           =   4935
   End
   Begin VB.Label Label1 
      Caption         =   "DTheta"
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   7
      Top             =   480
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Length Scale"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Depth"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   5
      Top             =   1080
      Width           =   495
   End
End
Attribute VB_Name = "frmBinTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const PI = 3.14159265
' Recursively draw a binary tree branch.
Private Sub DrawBranch(ByVal depth As Integer, ByVal X As Single, ByVal Y As Single, ByVal length As Single, ByVal theta As Single, ByVal length_scale As Single, ByVal dtheta As Single)
Dim x1 As Integer
Dim y1 As Integer

    ' See where this branch should end.
    x1 = X + length * Cos(theta)
    y1 = Y + length * Sin(theta)
    picCanvas.Line (X, Y)-(x1, y1)

    ' If depth > 1, draw the attached branches.
    If depth > 1 Then
        DrawBranch depth - 1, x1, y1, length * length_scale, theta + dtheta, length_scale, dtheta
        DrawBranch depth - 1, x1, y1, length * length_scale, theta - dtheta, length_scale, dtheta
    End If
End Sub

' Draw the tree.
Private Sub cmdGo_Click()
Dim depth As Integer
Dim start_length As Single
Dim length_scale As Single
Dim dtheta As Single

    depth = CInt(txtDepth.Text)
    If depth > 15 Then
        If MsgBox("A large depth may take a long time to draw. Do you want to continue?", _
            vbYesNo Or vbQuestion, "Continue?") = vbNo _
        Then
            Exit Sub
        End If
    End If

    length_scale = CSng(txtLengthScale.Text)
    dtheta = PI * CSng(txtDTheta.Text) / 180
    start_length = (picCanvas.ScaleHeight - 10) / _
        ((1 - length_scale ^ (depth + 1)) / (1 - length_scale))

    picCanvas.Cls
    MousePointer = vbHourglass
    DoEvents

    DrawBranch depth, _
        picCanvas.ScaleWidth \ 2, _
        picCanvas.ScaleHeight - 5, _
        start_length, -PI / 2, _
        length_scale, dtheta

    MousePointer = vbDefault
End Sub
' Make the canvas as big as possible.
Private Sub Form_Resize()
Dim wid As Single

    wid = ScaleWidth - picCanvas.Left
    If wid < 120 Then wid = 120
    picCanvas.Move picCanvas.Left, 0, wid, ScaleHeight
End Sub

